From 74201522208522677b3d81ce07d8cb3d75c0d139 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Tue, 14 Jul 2020 18:28:33 +0800
Subject: [PATCH 153/173] ath11k: don't send msi info to firmware for lmac
 rings

For QCA6390, firmware doesn't set msi_data for lmac rings so host
shouldn't sent msi_addr and msi_data to firmware. Otherwise, the
interrupt is routed to MHI mistakenly.

Tested-on: QCA6390 hw2.0 PCI WLAN.HST.1.0.1-01740-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: Icd3fd99704d8b80b30281c33e9adbbd3ebd566bf
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>

Conflicts:
	drivers/net/wireless/ath/ath11k/core.c
	drivers/net/wireless/ath/ath11k/hw.h
---
 drivers/net/wireless/ath/ath11k/core.c  |  2 ++
 drivers/net/wireless/ath/ath11k/dp_tx.c | 12 +++++++++---
 drivers/net/wireless/ath/ath11k/hw.h    |  1 +
 3 files changed, 12 insertions(+), 3 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index 647621d..40b27f9d 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -38,6 +38,7 @@
 		.wakeup_mhi = false,
 		.shadow_support = false,
 		.shadow_support_fix = false,
+		.lmac_interrupt = true,
 	},
 	{
 		.name = "qca6390",
@@ -57,6 +58,7 @@
 		.wakeup_mhi = true,
 		.shadow_support = true,
 		.shadow_support_fix = true,
+		.lmac_interrupt = false,
 	}
 };
 
diff --git a/drivers/net/wireless/ath/ath11k/dp_tx.c b/drivers/net/wireless/ath/ath11k/dp_tx.c
index 43300b5..b580cba 100644
--- a/drivers/net/wireless/ath/ath11k/dp_tx.c
+++ b/drivers/net/wireless/ath/ath11k/dp_tx.c
@@ -769,9 +769,15 @@ int ath11k_dp_tx_htt_srng_setup(struct ath11k_base *ab, u32 ring_id,
 	cmd->ring_tail_off32_remote_addr_hi = (u64)tp_addr >>
 					      HAL_ADDR_MSB_REG_SHIFT;
 
-	cmd->ring_msi_addr_lo = params.msi_addr & 0xffffffff;
-	cmd->ring_msi_addr_hi = ((uint64_t)(params.msi_addr) >> 32) & 0xffffffff;
-	cmd->msi_data = params.msi_data;
+	if (ab->hw_params.lmac_interrupt) {
+		cmd->ring_msi_addr_lo = lower_32_bits(params.msi_addr);
+		cmd->ring_msi_addr_hi = upper_32_bits(params.msi_addr);
+		cmd->msi_data = params.msi_data;
+	} else {
+		cmd->ring_msi_addr_lo = 0;
+		cmd->ring_msi_addr_hi = 0;
+		cmd->msi_data = 0;
+	}
 
 	cmd->intr_info = FIELD_PREP(
 			HTT_SRNG_SETUP_CMD_INTR_INFO_BATCH_COUNTER_THRESH,
diff --git a/drivers/net/wireless/ath/ath11k/hw.h b/drivers/net/wireless/ath/ath11k/hw.h
index fa3eff1..91db557 100644
--- a/drivers/net/wireless/ath/ath11k/hw.h
+++ b/drivers/net/wireless/ath/ath11k/hw.h
@@ -144,6 +144,7 @@ struct ath11k_hw_params {
 	bool wakeup_mhi;
 	bool shadow_support;
 	bool shadow_support_fix;
+	bool lmac_interrupt;
 };
 
 struct ath11k_fw_ie {
-- 
1.9.1

